/*

    Copyright 2005 Manuel Urbano Santos, Pablo J. Urbano Santos
    
    This file is part of Gdado.

    Gdado is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gdado is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gdado; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

// Global variables declared in main.c
GtkWidget *wg;		// For using as global variable. Looking for a more elegant way...

extern gboolean opt_separatedlines;
extern gboolean opt_sumresults;
extern gboolean opt_onlyfinalresult;	//Options


void 
on_window_gdado_destroy(GtkObject     *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
}

void
on_about1_destroy(GtkObject     *object,
                                        gpointer         user_data)
{

}


void
on_menu_calculator1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{/*
  GtkWidget *calcu;

  calcu = create_calculator ();
  gtk_widget_show (calcu);*/
}


void
on_menu_options2_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_menu_separatedlines1_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  opt_separatedlines = gtk_check_menu_item_get_active  ( menuitem );
}


void
on_menu_sumresults1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  opt_sumresults = gtk_check_menu_item_get_active  (menuitem );
  
  if (!opt_sumresults)
  {
    gtk_check_menu_item_set_active (lookup_widget(GTK_WIDGET (wg), "menu_onlyfinalresult"), FALSE);
    opt_onlyfinalresult = FALSE;
  }
  

}


void
on_menu_onlyfinalresult_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  opt_onlyfinalresult = gtk_check_menu_item_get_active  (menuitem);
  
  // sumresults must be active if onlyfinalresult is active
  
  if (opt_onlyfinalresult)
  {
    gtk_check_menu_item_set_active (lookup_widget(GTK_WIDGET (wg), "menu_sumresults1"), TRUE);
    opt_sumresults = TRUE; 
  }
}


void
on_salir1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_menu_sides1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_menu_d3_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 3 );
}


void
on_menu_d4_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 4 );

}


void
on_menu_d6_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 6 );

}


void
on_menu_d8_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 8 );

}


void
on_menu_d10_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 10 );

}


void
on_menu_d12_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 12 );

}


void
on_menu_d20_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 20 );

}


void
on_menu_d100_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_spin_button_set_value( (GtkSpinButton*) lookup_widget(GTK_WIDGET (menuitem), "spinbutton_nsides"), 100 );

}


void
on_menu_about1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  GtkWidget *about1;

  about1 = create_about1 ();
  gtk_widget_show (about1);
}


void
on_spinbutton_ndices_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
}


void
on_button_roll_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  int i;
  char *aux = NULL;
  GtkTextBuffer *buffer;

  gint ndices;		// Number of dices
  gint nsides;		// Number of sides by die
  gint results[1000];	// Contains the result of each individual die


  ndices = gtk_spin_button_get_value_as_int( lookup_widget(GTK_WIDGET (wg), "spinbutton_ndices") );

  nsides = gtk_spin_button_get_value_as_int( lookup_widget(GTK_WIDGET (wg), "spinbutton_nsides") );

  
  for ( i=0 ; i<ndices ; i++ )
    results[i] = g_random_int_range(1, nsides+1);
  
  aux = giveResult(results, ndices, opt_separatedlines, opt_sumresults, opt_onlyfinalresult);


  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (lookup_widget(GTK_WIDGET(button), "textview_result")));

  gtk_text_buffer_set_text (buffer, aux, -1);
  
  
  free(aux);
  aux = NULL;
}


void
on_spinbutton_nsides_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{

}

