/*

    Copyright 2005 Manuel Urbano Santos, Pablo J. Urbano Santos
    
    This file is part of Gdado.

    Gdado is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gdado is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gdado; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

/*
 * Format the output with the array of the dices given 
 * 
 */

char *giveResult(gint array[], gint nelements, gboolean opt_separatedlines, gboolean opt_sumresults, gboolean opt_onlyfinalresult)
{
  int i;
  char temp[10];
  char *tmpstring;
  int aux=0;
  
  // Reserve memory for all the array
  tmpstring = (char*) malloc ( (nelements*10+10) * sizeof(char));
  
  strncpy (tmpstring, "", 1);
  
  // Copy and transform from gdado 1.0

  if (!opt_onlyfinalresult) {
    for(i=0; i<(nelements-1); i++){
      sprintf(temp,"%d ", array[i]);
      strcat(tmpstring, temp);
    
      if (opt_sumresults && !opt_separatedlines) {
        strcat(tmpstring, "+ ");
      }
      
      if (opt_separatedlines) {
        strcat(tmpstring, "\n");
      }
    } // end of loop 

    // Last result is out of the loop in order to avoid the '+' to be writen
    sprintf(temp,"%d ", array[nelements-1]);
    strcat(tmpstring, temp);
    
    if (opt_separatedlines) {
      strcat(tmpstring, "\n");
      if (opt_sumresults) {
        strcat(tmpstring, "---\n");
      }
    }
      
    else if (opt_sumresults) {
        strcat(tmpstring, "= ");
      }

  }
  if (opt_sumresults) {
    for ( i=0 ; i<nelements ; i++ )
  	aux += array[i];
      sprintf(temp,"%d", aux);
      strcat(tmpstring, temp);
  }
  
  if (nelements==1)
    sprintf(tmpstring, "%d", array[0]);
    
  return tmpstring;   
} 
